<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace EventcorrelationModule\Lib;


use App\Lib\PluginAclDependencies;

class AclDependencies extends PluginAclDependencies {

    public function __construct() {
        parent::__construct();

        // Add actions that should always be allowed.
        $this
            ->allow('Eventcorrelations', 'reorganizeEvcStructure')
            ->allow('Eventcorrelations', 'getServiceWithStateById')
            ->allow('Eventcorrelations', 'loadServicesByString')
            ->allow('Eventcorrelations', 'serviceUsedBy')
            ->allow('Eventcorrelations', 'hostUsedBy')
            ->allow('Eventcorrelations', 'evcWidget')
            ->allow('Eventcorrelations', 'validateModalAddVServices')
            ->allow('Eventcorrelations', 'validateModalEditVServices');

        ///////////////////////////////
        //    Add dependencies       //
        //////////////////////////////

        $this
            ->dependency('Eventcorrelations', 'view', 'Eventcorrelations', 'getServicestatus')
            ->dependency('Eventcorrelations', 'summary_view', 'Eventcorrelations', 'summary_view_table');

        $this
            ->dependency('Eventcorrelations', 'add', 'Eventcorrelations', 'loadContainers')
            ->dependency('Eventcorrelations', 'add', 'Eventcorrelations', 'loadElementsByContainerId')
            ->dependency('Eventcorrelations', 'add', 'Eventcorrelations', 'loadHosttemplate')
            ->dependency('Eventcorrelations', 'add', 'Eventcorrelations', 'loadServicesByString');
    }
}
