<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>

<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fas fa-puzzle-piece"></i> <?php echo __('Event Correlation Module'); ?>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="EventcorrelationsSettingsIndex">
            <i class="fa fa-gears"></i> <?php echo __('Configuration'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fa fa-edit"></i> <?php echo __('Edit'); ?>
    </li>
</ol>

<div class="alert bg-warning-500 alert-dismissible alert-warning alert-dismissible" role="alert">
    <div class="d-flex align-items-center">
        <div class="alert-icon width-3">
            <div class='icon-stack  icon-stack-sm'>
                <i class="base base-9 icon-stack-3x opacity-100 text-primary"></i>
                <i class="fas fa-exclamation-circle icon-stack-1x opacity-100 color-white"></i>
            </div>
        </div>
        <div class="flex-1">
            <span class="h5"><?php echo __('Attention!'); ?></span>
            <?php echo __('This changes affects all event correlations'); ?>
        </div>
    </div>
</div>

<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Event Correlation Settings'); ?>
                </h2>
            </div>
            <div class="panel-container show">
                <div class="panel-content">
                    <form ng-submit="submit();">
                        <div class="frame-wrap">

                            <div class="form-group" ng-class="{'has-error': errors.EVC_CONSIDER_STATETYPE}">
                                <div class="custom-control custom-checkbox  margin-bottom-10"
                                     ng-class="{'has-error': errors.EVC_CONSIDER_STATETYPE}">

                                    <input type="checkbox"
                                           class="custom-control-input"
                                           id="EVC_CONSIDER_STATETYPE"
                                           ng-model="post.EVC_CONSIDER_STATETYPE">
                                    <label class="custom-control-label" for="EVC_CONSIDER_STATETYPE">
                                        <?= __('Consider state type') ?>
                                    </label>
                                </div>

                                <div class="col col-xs-12 col-md-offset-2 help-block">
                                    <?= __('If disabled every state type will be considered to calculate the event correlation result. If enabled only "hard state" events will be used.') ?>
                                </div>
                            </div>


                            <div class="form-group" ng-class="{'has-error': errors.EVC_CONSIDER_STATE_COUNT}">
                                <div class="custom-control custom-checkbox  margin-bottom-10"
                                     ng-class="{'has-error': errors.EVC_CONSIDER_STATE_COUNT}">

                                    <input type="checkbox"
                                           class="custom-control-input"
                                           id="EVC_CONSIDER_STATE_COUNT"
                                           ng-model="post.EVC_CONSIDER_STATE_COUNT">
                                    <label class="custom-control-label" for="EVC_CONSIDER_STATE_COUNT">
                                        <?= __('Consider state count') ?>
                                    </label>
                                </div>

                                <div class="col col-xs-12 col-md-offset-2 help-block">
                                    <?= __('If enabled, services in unknown state are ignored if there are more other services in critical or warning state.') ?>
                                </div>
                            </div>


                            <div class="form-group" ng-class="{'has-error': errors.EVC_REFLECT_CRITICAL_STATE}">
                                <div class="custom-control custom-checkbox  margin-bottom-10"
                                     ng-class="{'has-error': errors.EVC_REFLECT_CRITICAL_STATE}">

                                    <input type="checkbox"
                                           class="custom-control-input"
                                           id="EVC_REFLECT_CRITICAL_STATE"
                                           ng-model="post.EVC_REFLECT_CRITICAL_STATE">
                                    <label class="custom-control-label" for="EVC_REFLECT_CRITICAL_STATE">
                                        <?= __('Reflect status to host') ?>
                                    </label>
                                </div>

                                <div class="col col-xs-12 col-md-offset-2 help-block">
                                    <?= __('If enabled, the event correlation host will go in "down" state if the last element (root) of the event correlation is in "critical" state ') ?>
                                </div>
                            </div>

                            <div class="form-group required" ng-class="{'has-error': errors.monitoring_system}">
                                <label class="col col-md-2 control-label">
                                    <?php echo __('Check result submit method'); ?>
                                </label>
                                <div class="col col-xs-10">
                                    <select data-placeholder="<?php echo __('Please choose'); ?>"
                                            class="form-control"
                                            chosen="{}"
                                            ng-model="post.monitoring_system">
                                        <option value="statusengine"><?php echo __('Statusengine Event Broker (Naemon and Naemon) (Recommend)'); ?></option>
                                        <option value="naemon"><?php echo __('Query Handler (Naemon only - naemon.qh) (Recommend over nagios.cmd)'); ?></option>
                                        <option value="nagios"><?php echo __('External commands pipe (Nagios and Nameon - nagios.cmd)'); ?></option>

                                    </select>

                                    <div ng-repeat="error in errors.monitoring_system">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>

                                    <div class="help-block">
                                        <?php echo __('If Statusengine Event Broker or Naemons Query Handler will be used to submit correlation results a detailed long output will be passed to the monitoring engine. The external command pipe does not support long output.'); ?>
                                    </div>

                                </div>
                            </div>

                            <div class="form-group">
                                <label class="col col-md-2 control-label">
                                    <?php echo __('Status for disabled service'); ?>
                                </label>
                                <div class="col col-xs-10">
                                    <select data-placeholder="<?php echo __('Please choose'); ?>"
                                            class="form-control"
                                            chosen="{}"
                                            ng-model="post.status_disabled_service">
                                        <option ng-value="0"><?php echo __('Ok'); ?></option>
                                        <option ng-value="1"><?php echo __('Warning'); ?></option>
                                        <option ng-value="2"><?php echo __('Critical'); ?></option>
                                        <option ng-value="3"><?php echo __('Unknown'); ?></option>
                                    </select>
                                    <div ng-repeat="error in errors.status_disabled_service">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>

                                    <div class="help-block">
                                        <?php echo __('This status will be used for disabled services.'); ?>
                                    </div>
                                </div>
                            </div>

                            <div class="form-group" ng-class="{'has-error': errors.EVC_SHOW_INFO_FOR_DISABLED_SERVICES}">
                                <div class="custom-control custom-checkbox  margin-bottom-10"
                                     ng-class="{'has-error': errors.EVC_SHOW_INFO_FOR_DISABLED_SERVICES}">

                                    <input type="checkbox"
                                           class="custom-control-input"
                                           id="EVC_SHOW_INFO_FOR_DISABLED_SERVICES"
                                           ng-model="post.EVC_SHOW_INFO_FOR_DISABLED_SERVICES">
                                    <label class="custom-control-label" for="EVC_SHOW_INFO_FOR_DISABLED_SERVICES">
                                        <?= __('Show note for disabled services') ?>
                                    </label>
                                </div>

                                <div class="col col-xs-12 col-md-offset-2 help-block">
                                    <?= __('If enabled, shows note if event correlation contains disabled services.') ?>
                                </div>
                            </div>

                            <div class="card margin-top-10">
                                <div class="card-body">
                                    <div class="float-right">
                                        <button class="btn btn-primary" type="submit">
                                            <?php echo __('Save'); ?>
                                        </button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>

