<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fas fa-puzzle-piece"></i> <?php echo __('Event Correlation Module'); ?>
    </li>
    <li class="breadcrumb-item">
        <?php if ($this->Acl->hasPermission('index', 'eventcorrelations', 'EventcorrelationModule')): ?>
            <a ui-sref="EventcorrelationsIndex">
                <i class="fas fa-list"></i> <?php echo __('Event Correlations'); ?>
            </a>
        <?php else: ?>
            <i class="fas fa-list"></i> <?php echo __('Event Correlations'); ?>
        <?php endif; ?>
    </li>
    <li class="breadcrumb-item">
        <i class="fa fa-plus"></i> <?php echo __('Create new correlation'); ?>
    </li>
</ol>

<div class="alert alert-warning alert-dismissible fade show ng-hide" role="alert" ng-show="showRootAlert">
    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
        <span aria-hidden="true"><i class="fas fa-times"></i></span>
    </button>
    <div class="d-flex align-items-center">
        <div class="alert-icon width-3">
            <div class='icon-stack  icon-stack-sm'>
                <i class="base base-9 icon-stack-3x opacity-100 color-warning-600"></i>
                <i class="fas fa-exclamation-circle icon-stack-1x opacity-100 color-white"></i>
            </div>
        </div>
        <div class="flex-1">
            <span class="h5 m-0 fw-700"><?php echo __('/root container selected!'); ?></span>
            <?php echo __('Choosing a tenant container is recommended for later permission purposes'); ?>
        </div>
    </div>
</div>


<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Create new Event Correlation'); ?>
                </h2>
                <div class="panel-toolbar">
                    <?php if ($this->Acl->hasPermission('index', 'eventcorrelations', 'EventcorrelationModule')): ?>
                        <a back-button href="javascript:void(0);" fallback-state='EventcorrelationsIndex'
                           class="btn btn-default btn-xs mr-1 shadow-0">
                            <i class="fas fa-long-arrow-alt-left"></i> <?php echo __('Back'); ?>
                        </a>
                    <?php endif; ?>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">
                    <form ng-submit="submit();" class="form-horizontal"
                          ng-init="successMessage=
                            {objectName : '<?php echo __('Event Correlation'); ?>' , message: '<?php echo __('created successfully'); ?>'}">

                        <!-- BASIC CONFIGURATION START -->

                        <div class="card margin-bottom-10">
                            <div class="card-header">
                                <i class="fa-solid fa-wand-magic-sparkles"></i> <?php echo __('Basic configuration'); ?>
                            </div>
                            <div class="card-body">
                                <div class="form-group required" ng-class="{'has-error': errors.container_id}">
                                    <label class="control-label" for="HostContainer">
                                        <?php echo __('Container'); ?>
                                    </label>
                                    <select
                                            id="HostContainer"
                                            data-placeholder="<?php echo __('Please choose'); ?>"
                                            class="form-control"
                                            chosen="containers"
                                            ng-options="container.key as container.value for container in containers"
                                            ng-model="post.Host.container_id">
                                    </select>
                                    <div ng-show="post.Host.container_id < 1" class="warning-glow">
                                        <?php echo __('Please select a container.'); ?>
                                    </div>
                                    <div ng-repeat="error in errors.container_id">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                </div>

                                <div class="form-group required" ng-class="{'has-error': errors.hosttemplate_id}">
                                    <label class="control-label" for="HostTemplate">
                                        <?php echo __('Host template'); ?>
                                    </label>
                                    <select
                                            id="HostTemplate"
                                            data-placeholder="<?php echo __('Please choose'); ?>"
                                            class="form-control"
                                            chosen="hosttemplates"
                                            ng-options="hosttemplate.key as hosttemplate.value for hosttemplate in hosttemplates"
                                            ng-model="post.Host.hosttemplate_id">
                                    </select>
                                    <div ng-show="post.Host.hosttemplate_id < 1" class="warning-glow">
                                        <?php echo __('Please select a host template.'); ?>
                                    </div>
                                    <div ng-repeat="error in errors.hosttemplate_id">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                </div>

                                <div class="form-group required" ng-class="{'has-error': errors.name}">
                                    <label class="control-label">
                                        <?php echo __('Host name / Name of correlation'); ?>
                                    </label>
                                    <input
                                            id="HostName"
                                            class="form-control"
                                            type="text"
                                            ng-model="post.Host.name">
                                    <div ng-repeat="error in errors.name">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                </div>

                                <div ng-show="post.Host.hosttemplate_id">
                                    <div class="form-group" ng-class="{'has-error': errors.description}">
                                        <label class="control-label">
                                            <?php echo __('Description'); ?>
                                        </label>
                                        <div class="input-group">
                                            <input
                                                    class="form-control"
                                                    type="text"
                                                    ng-model="post.Host.description">

                                            <template-diff ng-show="post.Host.hosttemplate_id"
                                                           value="post.Host.description"
                                                           template-value="hosttemplate.Hosttemplate.description"></template-diff>
                                        </div>
                                        <div ng-repeat="error in errors.description">
                                            <div class="help-block text-danger">{{ error }}</div>
                                        </div>
                                    </div>

                                    <div class="form-group" ng-class="{'has-error': errors.priority}">
                                        <label class="control-label">
                                            <?php echo __('Priority'); ?>
                                        </label>
                                        <div class="col-xs-12 col-lg-2">
                                            <priority-directive priority="post.Host.priority"
                                                                callback="setPriority"></priority-directive>
                                            <template-diff-button ng-show="post.Host.hosttemplate_id"
                                                                  value="post.Host.priority"
                                                                  template-value="hosttemplate.Hosttemplate.priority">
                                            </template-diff-button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <!-- BASIC CONFIGURATION END -->

                        <!-- CHECK CONFIGURATION START -->
                        <div class="card margin-bottom-10" ng-show="post.Host.hosttemplate_id">
                            <div class="card-header">
                                <i class="fa fa-terminal"></i> <?php echo __('Check configuration'); ?>
                            </div>
                            <div class="card-body">
                                <div class="form-group"
                                     ng-class="{'has-error': errors.check_period_id}">
                                    <label class="control-label">
                                        <?php echo __('Check period'); ?>
                                    </label>
                                    <div class="input-group" style="width: 100%;">
                                        <select
                                                id="CheckPeriodSelect"
                                                data-placeholder="<?php echo __('Please choose'); ?>"
                                                class="form-control"
                                                chosen="checkperiods"
                                                ng-options="checkperiod.key as checkperiod.value for checkperiod in checkperiods"
                                                ng-model="post.Host.check_period_id">
                                        </select>
                                        <template-diff ng-show="post.Host.hosttemplate_id"
                                                       value="post.Host.check_period_id"
                                                       template-value="hosttemplate.Hosttemplate.check_period_id"></template-diff>
                                    </div>
                                    <div class="help-block" ng-hide="post.Host.check_period_id">
                                        <?php echo __('Due to active checking is disabled, this command will only be used as freshness check command.'); ?>
                                    </div>
                                    <div ng-repeat="error in errors.check_period_id">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                </div>

                                <div class="form-group required" ng-class="{'has-error': errors.check_interval}">
                                    <label class="col-xs-12 col-lg-2 control-label">
                                        <?php echo __('Check interval'); ?>
                                    </label>
                                    <interval-input-with-differ-directive
                                            template-id="post.Host.hosttemplate_id"
                                            interval="post.Host.check_interval"
                                            template-value="hosttemplate.Hosttemplate.check_interval"></interval-input-with-differ-directive>
                                    <div class="col-xs-12 col-lg-offset-2">
                                        <div ng-repeat="error in errors.check_interval">
                                            <div class="help-block text-danger">{{ error }}</div>
                                        </div>
                                    </div>
                                </div>

                                <div class="form-group required" ng-class="{'has-error': errors.retry_interval}">
                                    <label class="col-xs-12 col-lg-2 control-label">
                                        <?php echo __('Retry interval'); ?>
                                    </label>
                                    <interval-input-with-differ-directive
                                            template-id="post.Host.hosttemplate_id"
                                            interval="post.Host.retry_interval"
                                            template-value="hosttemplate.Hosttemplate.retry_interval"></interval-input-with-differ-directive>

                                    <div class="col-xs-12 col-lg-offset-2">
                                        <div ng-repeat="error in errors.retry_interval">
                                            <div class="help-block text-danger">{{ error }}</div>
                                        </div>
                                    </div>
                                </div>


                                <div class="form-group"
                                     ng-class="{'has-error': errors.max_check_attempts}">
                                    <label class="col-xs-12 col-lg-2 control-label">
                                        <?php echo __('Max. number of check attempts'); ?>
                                    </label>
                                    <div class="row">
                                        <div class="col-xs-12 col-lg-6">
                                            <div class="btn-group flex-wrap">
                                                <?php for ($i = 1; $i <= 10; $i++): ?>
                                                    <button
                                                            type="button"
                                                            class="btn btn-default"
                                                            ng-click="post.Host.max_check_attempts = <?php echo h($i) ?>"
                                                            ng-class="{'active': post.Host.max_check_attempts == <?php echo h($i); ?>}">
                                                        <?php echo h($i); ?>
                                                    </button>
                                                <?php endfor; ?>
                                            </div>
                                        </div>
                                        <div class="col-xs-12 col-lg-6">
                                            <div class="input-group" style="width: 100%;">
                                                <input
                                                        class="form-control"
                                                        type="number"
                                                        min="0"
                                                        ng-model="post.Host.max_check_attempts">
                                                <template-diff ng-show="post.Host.hosttemplate_id"
                                                               value="post.Host.max_check_attempts"
                                                               template-value="hosttemplate.Hosttemplate.max_check_attempts"></template-diff>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-xs-12 col-lg-offset-2 col-lg-12">
                                        <div class="help-block">
                                            <?php echo __('Number of failed attempts before the host will switch into hard state.'); ?>
                                        </div>
                                        <div class="help-block">
                                            <?php echo __('Worst case time delay until notification command gets executed after state hits a non ok state: '); ?>
                                            <human-time-directive
                                                    seconds="(post.Host.check_interval + (post.Host.max_check_attempts -1) * post.Host.retry_interval)"></human-time-directive>
                                        </div>
                                        <div ng-repeat="error in errors.max_check_attempts">
                                            <div class="help-block text-danger">{{ error }}</div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <!-- CHECK CONFIGURATION END -->


                        <!-- NOTIFICATION CONFIGURATION START -->
                        <div class="card margin-bottom-10" ng-show="post.Host.hosttemplate_id">
                            <div class="card-header">
                                <i class="fa fa-envelope-open"></i> <?php echo __('Notification configuration'); ?>
                            </div>
                            <div class="card-body">
                                <div class="form-group required"
                                     ng-class="{'has-error': errors.notify_period_id}">
                                    <label class="control-label">
                                        <?php echo __('Notification Period'); ?>
                                    </label>
                                    <div class="input-group" style="width: 100%;">
                                        <select
                                                id="HostCheckCommandSelect"
                                                data-placeholder="<?php echo __('Please choose'); ?>"
                                                class="form-control"
                                                chosen="timeperiods"
                                                ng-options="timeperiod.key as timeperiod.value for timeperiod in timeperiods"
                                                ng-model="post.Host.notify_period_id">
                                        </select>
                                        <template-diff ng-show="post.Host.hosttemplate_id"
                                                       value="post.Host.notify_period_id"
                                                       template-value="hosttemplate.Hosttemplate.notify_period_id"></template-diff>
                                    </div>
                                    <div ng-repeat="error in errors.notify_period_id">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                </div>

                                <div class="form-group required"
                                     ng-class="{'has-error': errors.notification_interval}">
                                    <label class="col-xs-12 col-lg-2 control-label">
                                        <?php echo __('Notification interval'); ?>
                                    </label>
                                    <interval-input-with-differ-directive
                                            template-id="post.Host.hosttemplate_id"
                                            interval="post.Host.notification_interval"
                                            template-value="hosttemplate.Hosttemplate.notification_interval"></interval-input-with-differ-directive>
                                    <div class="col-xs-12 col-lg-offset-2">
                                        <div ng-repeat="error in errors.notification_interval">
                                            <div class="help-block text-danger">{{ error }}</div>
                                        </div>
                                    </div>
                                </div>

                                <div class="form-group"
                                     ng-class="{'has-error': errors.contacts}">
                                    <label class="control-label">
                                        <?php echo __('Contacts'); ?>
                                    </label>
                                    <div class="input-group" style="width: 100%;">
                                        <select
                                                id="ContactsPeriodSelect"
                                                data-placeholder="<?php echo __('Please choose'); ?>"
                                                class="form-control"
                                                chosen="contacts"
                                                multiple
                                                ng-options="contact.key as contact.value for contact in contacts"
                                                ng-model="post.Host.contacts._ids">
                                        </select>
                                        <template-diff ng-show="post.Host.hosttemplate_id"
                                                       value="post.Host.contacts._ids"
                                                       template-value="hosttemplate.Hosttemplate.contacts._ids"></template-diff>
                                    </div>
                                    <div ng-repeat="error in errors.contacts">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                </div>

                                <div class="form-group"
                                     ng-class="{'has-error': errors.contactgroups}">
                                    <label class="control-label">
                                        <?php echo __('Contact groups'); ?>
                                    </label>
                                    <div class="input-group" style="width: 100%;">
                                        <select
                                                id="ContactgroupsSelect"
                                                data-placeholder="<?php echo __('Please choose'); ?>"
                                                class="form-control"
                                                chosen="contactgroups"
                                                multiple
                                                ng-options="contactgroup.key as contactgroup.value for contactgroup in contactgroups"
                                                ng-model="post.Host.contactgroups._ids">
                                        </select>
                                        <template-diff ng-show="post.Host.hosttemplate_id"
                                                       value="post.Host.contactgroups._ids"
                                                       template-value="hosttemplate.Hosttemplate.contactgroups._ids"></template-diff>
                                    </div>
                                    <div ng-repeat="error in errors.contactgroups">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                </div>


                                <?php
                                $hostOptions = [
                                    [
                                        'field' => 'notify_on_recovery',
                                        'class' => 'success',
                                        'text'  => __('Recovery')
                                    ],
                                    [
                                        'field' => 'notify_on_down',
                                        'class' => 'danger',
                                        'text'  => __('Down')
                                    ],
                                    [
                                        'field' => 'notify_on_unreachable',
                                        'class' => 'secondary',
                                        'text'  => __('Unreachable')
                                    ],
                                    [
                                        'field' => 'notify_on_flapping',
                                        'class' => 'primary',
                                        'text'  => __('Flapping')
                                    ],
                                    [
                                        'field' => 'notify_on_downtime',
                                        'class' => 'primary',
                                        'text'  => __('Downtime')
                                    ],
                                ];
                                ?>
                                <fieldset>
                                    <legend class="fs-sm"
                                            ng-class="{'has-error-no-form': errors.notify_on_recovery}">
                                        <div class="required">
                                            <label class="fs-sm">
                                                <?php echo __('Host notification options'); ?>
                                            </label>

                                            <div ng-repeat="error in errors.notify_on_recovery">
                                                <div class="text-danger">{{ error }}</div>
                                            </div>
                                        </div>
                                    </legend>
                                    <div class="row">
                                        <?php foreach ($hostOptions as $hostOption): ?>
                                            <div
                                                    class="custom-control custom-checkbox margin-bottom-10 custom-control-right"
                                                    ng-class="{'has-error': errors.<?php echo $hostOption['field']; ?>}">
                                                <input type="checkbox"
                                                       class="custom-control-input"
                                                       ng-true-value="1"
                                                       ng-false-value="0"
                                                       id="<?php echo $hostOption['field']; ?>"
                                                       ng-model="post.Host.<?php echo $hostOption['field']; ?>">
                                                <label for="<?php echo $hostOption['field']; ?>"
                                                       class="col col-md-6 custom-control-label custom-control-label-<?php echo $hostOption['class']; ?> padding-top-0 margin-right-10 ">
                                                        <span
                                                                class="badge badge-<?php echo $hostOption['class']; ?> notify-label-small">
                                                            <?php echo $hostOption['text']; ?>
                                                        </span>
                                                </label>
                                                <span class="margin-left-15">
                                                    <template-diff-button ng-show="post.Host.hosttemplate_id"
                                                                          value="post.Host.<?php echo $hostOption['field']; ?>"
                                                                          template-value="hosttemplate.Hosttemplate.<?php echo $hostOption['field']; ?>">
                                                </template-diff-button>
                                                </span>
                                            </div>
                                        <?php endforeach; ?>
                                    </div>
                                </fieldset>
                            </div>
                        </div>
                        <!-- NOTIFICATION CONFIGURATION END -->

                        <div class="card margin-top-10">
                            <div class="card-body">
                                <div class="float-right">

                                    <button type="submit" class="btn btn-primary waves-effect waves-themed">
                                        <?php echo __('Create event correlation'); ?>
                                    </button>

                                    <a back-button href="javascript:void(0);" fallback-state='EventcorrelationsIndex'
                                       class="btn btn-default">
                                        <?php echo __('Cancel'); ?>
                                    </a>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
