<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fas fa-puzzle-piece"></i> <?php echo __('Event Correlation Module'); ?>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="EventcorrelationsIndex">
            <i class="fas fa-list"></i> <?php echo __('Event Correlations'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fa fa-edit"></i> <?php echo __('Edit correlation'); ?>
    </li>
</ol>


<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Edit Event Correlation:'); ?>
                    <span class="fw-300"><i>{{rootElement.host.name}}</i></span>
                </h2>
                <div class="panel-toolbar">

                    <button
                            class="btn btn-success btn-xs mr-1 shadow-0"
                            ng-click="saveEvcClick()">
                        <i class="fas fa-save"></i> <?php echo __('Save Event Correlation'); ?>
                    </button>

                    <?php if ($this->Acl->hasPermission('index', 'eventcorrelations', 'EventcorrelationModule')): ?>
                        <a back-button href="javascript:void(0);" fallback-state='EventcorrelationsIndex'
                           class="btn btn-default btn-xs mr-1 shadow-0">
                            <i class="fas fa-long-arrow-alt-left"></i> <?php echo __('Back'); ?>
                        </a>
                    <?php endif; ?>
                    <?php if ($this->Acl->hasPermission('view', 'eventcorrelations', 'EventcorrelationModule')): ?>
                        <button class="btn btn-default btn-xs mr-1 shadow-0" ui-sref="EventcorrelationsView({id: rootElement.host.id})">
                            <i class="fa fa-eye"></i> <?php echo __('View'); ?>
                        </button>
                    <?php endif; ?>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content frame-wrap">
                    <div class="padding-bottom-10">
                        <div class="no-padding d-flex">
                            <div>
                                <i class="fa fa-square no-padding ok"></i>
                                <em class="padding-right-10">
                                    <?php
                                    echo __('Ok');
                                    ?>
                                </em>
                                <i class="fa fa-square no-padding warning"></i>
                                <em class="padding-right-10">
                                    <?php
                                    echo __('Warning');
                                    ?>
                                </em>
                                <i class="fa fa-square no-padding critical"></i>
                                <em class="padding-right-10">
                                    <?php
                                    echo __('Critical');
                                    ?>
                                </em>
                                <i class="fa fa-square no-padding unknown"></i>
                                <em class="padding-right-10">
                                    <?php
                                    echo __('Unknown');
                                    ?>
                                </em>
                                <i class="fa fa-square no-padding text-primary"></i>
                                <em class="padding-right-10">
                                    <?php
                                    echo __('Not monitored');
                                    ?>
                                </em>
                                <i class="fa fa-square no-padding newVirtualService"></i>
                                <em class="padding-right-10 txt-color-blue">
                                    <?php
                                    echo __('New virtual service');
                                    ?>
                                </em>
                            </div>
                            <div class="ml-auto" ng-show="showInfoForDisabledService && disabledServices > 0">
                                <span class="padding-7 bg-warning-50 border border-warning rounded-lg">
                                    <span class="icon-stack icon-stack-sm margin-bottom-5">
                                        <i class="base-7 icon-stack-2x color-warning-600"></i>
                                        <i class="fas fa-exclamation icon-stack-1x text-white"></i>
                                    </span>
                                    <?= __('Event correlation includes disabled services!'); ?>
                                    <span class="help-block">
                                        [
                                        <?= __('Status for disabled service'); ?>
                                        <i class="fas fa-equals"></i>
                                        <span ng-switch="stateForDisabledService">
                                            <i class="fa fa-square no-padding ok"
                                               ng-switch-when="0"></i>
                                            <i class="fa fa-square no-padding warning"
                                               ng-switch-when="1"></i>
                                            <i class="fa fa-square no-padding critical"
                                               ng-switch-when="2"></i>
                                            <i class="fa fa-square no-padding unknown"
                                               ng-switch-when="3"></i>
                                        </span>
                                        ]
                                    </span>
                                    <?php if ($this->Acl->hasPermission('index', 'EventcorrelationSettings', 'EventcorrelationModule')): ?>
                                        <a class="btn btn-outline-warning btn-xs btn-w-m waves-effect waves-themed"
                                           ui-sref="EventcorrelationsSettingsIndex">
                                            <i class="fa fa-gears"></i>
                                            <?= __('Go to "Event Correlation Globals"'); ?>
                                        </a>
                                    <?php endif; ?>
                                </span>
                            </div>
                        </div>
                    </div>

                    <!-- EVC -->
                    <div>
                        <div class="widget-body evkWidgetBody"
                             ng-init="successMessage=
                            {objectName : '<?php echo __('Event Correlation '); ?>' , message: '<?php echo __('saved successfully'); ?>'}">

                            <div ng-if="evcTree.length === 0">
                                <!-- Fake container for empty evcTree -->
                                <div class="layerContainer globalLayerContainer">
                                    <button type="button" class="btn btn-xs btn-success addLayerBtn"
                                            ng-click="showAddVServiceModal(0)">
                                        <i class="fa fa-cog"></i>
                                        <?= __('New vService'); ?>
                                    </button>
                                </div>
                            </div>

                            <!-- Real EVC -->
                            <div id="evkDrawPad" style="position: relative;">
                                <div ng-repeat-start="evcLayer in evcTree" class="layerContainer globalLayerContainer"
                                     id="layer_{{$index+1}}" data-set-height="{{($index+1 > 1)?1:0}}"
                                     ng-class="{'alert-evc-warning':layerWithErrors[$index]}"
                                     ng-init="layerIndex = $index">

                                    <button type="button" class="btn btn-xs btn-success addLayerBtn"
                                            ng-click="showAddVServiceModal(layerIndex)">
                                        <i class="fa fa-cog"></i>
                                        <?= __('New vService'); ?>
                                    </button>

                                    <div ng-repeat="(virtualServiceId, services) in evcLayer"
                                         id="servicesContainer_{{virtualServiceId}}">
                                        <div ng-repeat="eventCorrelation in services" class="service"
                                             ng-class="{'service-alert missing-connection-icon':evcNodeWithErrors[eventCorrelation.id],
                                             'serviceDisabled disabledIcon': eventCorrelation.service.disabled,
                                             'animated_new infinite_new bounce_new': (eventCorrelation.service.host_id == highlightHostId) ||
                                              (eventCorrelation.service.id == highlightServiceId)}"
                                             id="service_{{eventCorrelation.id}}">
                                            <div id="{{eventCorrelation.id}}_vServiceEditDiv"
                                                 class="editBox text-center" ng-if="layerIndex > 0">
                                                <a class="btn pointer"><i class="fa fa-edit fa-lg"
                                                                          ng-click="showEditVServiceModal(layerIndex, eventCorrelation)"
                                                                          title="{{eventCorrelation.service.host.name}} / {{eventCorrelation.service.servicename}}"></i>
                                                </a>
                                                <a class="btn"
                                                   ng-if="eventCorrelation.usedBy.length > 0">
                                                    <i class="fa fa-lock warning helpText fa-lg"
                                                       title="{{ eventCorrelation.usedBy.join(', ') }}"></i>
                                                </a>
                                                <a class="btn pointer"
                                                   ng-click="deleteEvcNodeClick(layerIndex, eventCorrelation)"
                                                   ng-if="eventCorrelation.usedBy.length === 0">
                                                    <i class="fas fa-trash fa-lg"></i>
                                                </a>
                                            </div>

                                            <div class="serviceStateColor pull-left {{eventCorrelation.service.servicestatus.cssClass}}"></div>
                                            <div class="serviceInformation">
                                                <div class="hosttext ellipsis"
                                                     title="{{eventCorrelation.service.host.name}}">
                                                    <i class="fa fa-desktop"></i>
                                                    {{eventCorrelation.service.host.name}}
                                                </div>
                                                <div class="servicetext ellipsis"
                                                     title="{{eventCorrelation.service.servicename}}">
                                                    <i class="fa"
                                                       ng-class="{'fa-gear': eventCorrelation.service.service_type !== <?php echo EVK_SERVICE; ?>, 'fa-sitemap text-primary fa-rotate-90': eventCorrelation.service.service_type === <?php echo EVK_SERVICE; ?>}"></i>
                                                    {{eventCorrelation.service.servicename}}
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div ng-repeat-end="" class="nodeLayerContainer globalLayerContainer"
                                     ng-show="evcTree[layerIndex+1]" ng-init="$last?positionEvcTimeout():null"
                                     data-set-height="1">
                                    <div ng-repeat="services in evcTree[layerIndex+1]">
                                        <div ng-repeat="eventCorrelation in services">
                                            <div class="operator txt-color-white"
                                                 ng-if="eventCorrelation.operator"
                                                 id="{{eventCorrelation.id}}_nodeOperator"
                                                 data-is-positioned="0">
                                                {{eventCorrelation.operator}}
                                            </div>
                                        </div>
                                    </div>
                                </div>

                            </div>
                        </div>
                    </div>
                    <!-- EVC end -->

                </div>

            </div>
        </div>
    </div>
</div>

<!-- Service / vService modal -->
<div id="evcServicesModal" class="modal" role="dialog">
    <div class="modal-dialog modal-xl" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">
                    <i class="fa fa-wrench fa-flip-horizontal"></i>
                    <span ng-show="modalVService.current_evc.mode === 'add'"><?= __('Create virtual service'); ?></span>
                    <span ng-show="modalVService.current_evc.mode === 'edit'"><?= __('Modify virtual service'); ?></span>
                </h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true"><i class="fa fa-times"></i></span>
                </button>
            </div>
            <div class="modal-body">
                <div class="row">
                    <div class="col-lg-12">

                        <div class="form-group required" ng-class="{'has-error': errors.servicename}">
                            <label class="control-label">
                                <?php echo __('Name of vService'); ?>
                            </label>
                            <input
                                    class="form-control"
                                    type="text"
                                    ng-model="modalVService.servicename">
                        </div>
                        <div ng-repeat="error in errors.servicename">
                            <div class="help-block text-danger">{{ error }}</div>
                        </div>
                        <div class="help-block">
                            <?php echo __('Name of the virtual service that holds the result of the correlation.'); ?>
                        </div>
                    </div>

                    <div class="form-group col-lg-12 padding-top-10 required"
                         ng-class="{'has-error': errors.servicetemplate_id}">
                        <label class="control-label">
                            <?php echo __('Service template'); ?>
                        </label>
                        <select
                                data-placeholder="<?php echo __('Please choose'); ?>"
                                class="form-control"
                                chosen="servicetemplates"
                                ng-options="servicetemplate.key as servicetemplate.value for servicetemplate in servicetemplates"
                                ng-model="modalVService.servicetemplate_id">
                        </select>
                        <div ng-repeat="error in errors.servicetemplate_id">
                            <div class="help-block text-danger">{{ error }}</div>
                        </div>
                        <div class="help-block">
                            <?php echo __('Only service templates of the EVC type are available.'); ?>
                        </div>
                    </div>

                    <div class="form-group col-lg-12 padding-top-10 required" ng-if="modalCurrentLayerIndex === 0"
                         ng-class="{'has-error': errors.service_ids}">
                        <label class="control-label">
                            <?php echo __('Services'); ?>
                        </label>
                        <select
                                data-placeholder="<?php echo __('Please choose'); ?>"
                                class="form-control"
                                multiple
                                chosen="servicesForSelect"
                                callback="loadServices"
                                ng-options="+(service.value.Service.id) as (service.value.Service.disabled == 0)?(service.value.Host.name + '/' +service.value.Service.servicename):(service.value.Host.name + '/' +service.value.Service.servicename+'🔌')  group by service.value.Host.name for service in servicesForSelect"
                                ng-model="modalVService.service_ids">
                        </select>
                        <div ng-repeat="error in errors.service_ids">
                            <div class="help-block text-danger">{{ error }}</div>
                        </div>
                        <div class="help-block">
                            <?php echo __('Services that should be correlated'); ?>
                        </div>
                    </div>

                    <div class="form-group col-lg-12 padding-top-10 required" ng-if="modalCurrentLayerIndex > 0"
                         ng-class="{'has-error': errors.service_ids}">
                        <label class="control-label">
                            <?php echo __('vServices'); ?>
                        </label>
                        <!--
                        modalCurrentLayerIndex > 0
                        select with no callback and no ng-options with "+" (+ is an integer cast in AngularJS)
                        https://stackoverflow.com/a/33666568
                        -->
                        <select
                                data-placeholder="<?php echo __('Please choose'); ?>"
                                class="form-control"
                                multiple
                                chosen="servicesForSelect"
                                ng-options="(service.value.Service.id) as service.value.Host.name + '/' +service.value.Service.servicename group by service.value.Host.name disable when service.vServiceInUse for service in servicesForSelect"
                                ng-model="modalVService.service_ids">
                        </select>
                        <div ng-repeat="error in errors.service_ids">
                            <div class="help-block text-danger">{{ error }}</div>
                        </div>
                        <div class="help-block">
                            <?php echo __('Virtual services that should be correlated'); ?>
                        </div>
                    </div>


                    <div class="form-group col-lg-12 padding-top-10 required" ng-class="{'has-error': errors.operator}">
                        <label class="control-label">
                            <?php echo __('Operator'); ?>
                        </label>
                        <select
                                data-placeholder="<?php echo __('Please choose'); ?>"
                                class="form-control"
                                chosen="grafanaUnits"
                                ng-model="modalVService.operator">
                            <option value="and"><?= __('AND'); ?></option>
                            <option value="or"><?= __('OR'); ?></option>
                            <option value="eq"><?= __('EQUAL'); ?></option>
                            <option value="min"><?= __('MIN'); ?></option>
                        </select>
                        <div ng-repeat="error in errors.operator">
                            <div class="help-block text-danger">{{ error }}</div>
                        </div>
                    </div>

                    <div class="col-lg-12" ng-show="modalVService.operator === 'min'">
                        <div class="form-group required" ng-class="{'has-error': errors.operator_modifier}">
                            <label class="control-label">
                                <?php echo __('Operator modifier'); ?>
                            </label>
                            <input
                                    class="form-control"
                                    type="number"
                                    ng-model="modalVService.operator_modifier">
                        </div>
                        <div ng-repeat="error in errors.operator_modifier">
                            <div class="help-block text-danger">{{ error }}</div>
                        </div>
                    </div>

                </div>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-success" ng-click="validateModalForm()">
                    <i class="fa fa-spinner fa-spin" ng-show="showSpinner"></i>
                    <?php echo __('Save'); ?>
                </button>
                <button type="button" class="btn btn-default" data-dismiss="modal">
                    <?php echo __('Cancel'); ?>
                </button>
            </div>
        </div>
    </div>
</div>
