<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="EventcorrelationsIndex">
            <i class="fas fa-puzzle-piece"></i> <?php echo __('Event Correlation Module'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fa fa-list"></i> <?php echo __('Event Correlations Overview'); ?>
    </li>
</ol>

<!-- ANGAULAR DIRECTIVES -->
<massdelete></massdelete>

<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Event Correlations'); ?>
                    <span class="fw-300"><i><?php echo __('overview'); ?></i></span>
                </h2>
                <div class="panel-toolbar">
                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?php echo __('Refresh'); ?>
                    </button>
                    <?php if ($this->Acl->hasPermission('add', 'eventcorrelations', 'Eventcorrelationmodule')): ?>
                        <button class="btn btn-xs btn-success mr-1 shadow-0" ui-sref="EventcorrelationsAdd">
                            <i class="fas fa-plus"></i> <?php echo __('New'); ?>
                        </button>
                    <?php endif; ?>

                    <button class="btn btn-xs btn-primary shadow-0" ng-click="triggerFilter()">
                        <i class="fas fa-filter"></i> <?php echo __('Filter'); ?>
                    </button>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">

                    <!-- Start Filter -->
                    <div class="list-filter card margin-bottom-10" ng-show="showFilter">
                        <div class="card-header">
                            <i class="fa fa-filter"></i> <?php echo __('Filter'); ?>
                        </div>
                        <div class="card-body">
                            <div class="row">
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fa fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by event correlation name'); ?>"
                                                   ng-model="filter.Hosts.name"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fa fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by event correlation description'); ?>"
                                                   ng-model="filter.Hosts.description"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="float-right">
                                <button type="button" ng-click="resetFilter()"
                                        class="btn btn-xs btn-danger">
                                    <?php echo __('Reset Filter'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                    <!-- Filter End -->

                    <div class="frame-wrap">
                        <table class="table table-striped m-0 table-bordered table-hover table-sm">
                            <thead>
                            <tr>
                                <th class="no-sort sorting_disabled width-15">
                                    <i class="fa fa-check-square"></i>
                                </th>
                                <th class="no-sort" ng-click="orderBy('Hosts.name')">
                                    <i class="fa" ng-class="getSortClass('Hosts.name')"></i>
                                    <?php echo __('Event correlation name'); ?>
                                </th>
                                <th class="no-sort" ng-click="orderBy('Hosts.description')">
                                    <i class="fa" ng-class="getSortClass('Hosts.description')"></i>
                                    <?php echo __('Event correlation description'); ?>
                                </th>
                                <th class="no-sort text-center">
                                    <i class="fa fa-cog"></i>
                                </th>
                            </tr>
                            </thead>

                            <tbody>
                            <tr ng-repeat="host in evcHosts">
                                <td class="text-center" class="width-15">
                                    <?php if ($this->Acl->hasPermission('delete', 'eventcorrelations', 'EventcorrelationModule')): ?>
                                        <input type="checkbox"
                                               ng-model="massChange[host.Host.id]"
                                               ng-show="host.hasWritePermission">
                                    <?php endif; ?>
                                </td>
                                <td>
                                    <?php if ($this->Acl->hasPermission('view', 'eventcorrelations', 'EventcorrelationModule')): ?>
                                        <a ui-sref="EventcorrelationsView({id: host.Host.id})"
                                           ng-if="host.hasViewPermission">
                                            {{host.Host.name}}
                                        </a>
                                        <span ng-if="!host.hasViewPermission">{{host.Host.name}}
                                            <i class="fa fa-low-vision text-info"
                                               title="<?php echo __('This EVC contains Hosts you are not permitted to view'); ?>">
                                            </i>
                                        </span>
                                    <?php else: ?>
                                        {{host.Host.name}}
                                        <i class="fa fa-low-vision text-info"
                                           title="<?php echo __('This EVC contains Hosts you are not permitted to view'); ?>">
                                        </i>
                                    <?php endif; ?>
                                    <span class="badge border border-danger text-danger" ng-show="host.Host.disabled">
                                        <?= __('DISABLED'); ?>
                                        <i class="fas fa-plug"></i>
                                    </span>
                                </td>
                                <td>
                                    {{host.Host.description}}
                                </td>
                                <td class="width-50">
                                    <div class="btn-group btn-group-xs" role="group">
                                        <?php if ($this->Acl->hasPermission('editCorrelation', 'eventcorrelations', 'EventcorrelationModule')): ?>
                                            <a ui-sref="EventcorrelationsEditCorrelation({id: host.Host.id})"
                                               ng-if="host.hasWritePermission"
                                               class="btn btn-default btn-lower-padding">
                                                <i class="fa fa-cog"></i>
                                            </a>
                                            <a href="javascript:void(0);"
                                               ng-if="!host.hasWritePermission"
                                               class="btn btn-default btn-lower-padding disabled">
                                                <i class="fa fa-cog"></i>
                                            </a>
                                        <?php else: ?>
                                            <a href="javascript:void(0);"
                                               class="btn btn-default btn-lower-padding disabled">
                                                <i class="fa fa-cog"></i></a>
                                        <?php endif; ?>
                                        <button type="button"
                                                class="btn btn-default dropdown-toggle btn-lower-padding"
                                                data-toggle="dropdown">
                                            <i class="caret"></i>
                                        </button>
                                        <div class="dropdown-menu dropdown-menu-right">
                                            <?php if ($this->Acl->hasPermission('editCorrelation', 'eventcorrelations', 'EventcorrelationModule')): ?>
                                                <a ui-sref="EventcorrelationsEditCorrelation({id: host.Host.id})"
                                                   ng-if="host.hasWritePermission"
                                                   class="dropdown-item">
                                                    <i class="fa fa-cog"></i>
                                                    <?php echo __('Edit Correlation'); ?>
                                                </a>
                                            <?php endif; ?>
                                            <?php if ($this->Acl->hasPermission('edit', 'hosts', '')): ?>
                                                <a ui-sref="HostsEdit({id: host.Host.id})"
                                                   ng-if="host.hasWritePermission"
                                                   class="dropdown-item">
                                                    <i class="fa fa-desktop"></i>
                                                    <?php echo __('Edit host'); ?>
                                                </a>
                                            <?php endif; ?>
                                            <?php if ($this->Acl->hasPermission('usedBy', 'eventcorrelations', 'EventcorrelationModule')): ?>
                                                <div class="dropdown-divider" ng-if="host.hasViewPermission"></div>
                                                <a class="dropdown-item"
                                                   ui-sref="EventcorrelationsUsedBy({id: host.Host.id})"
                                                   ng-if="host.hasViewPermission">
                                                    <i class="fa fa-reply-all fa-flip-horizontal"></i>
                                                    <?php echo __('Used by'); ?>
                                                </a>
                                            <?php endif; ?>

                                            <?php if ($this->Acl->hasPermission('view', 'eventcorrelations', 'EventcorrelationModule')): ?>
                                                <div class="dropdown-divider" ng-if="host.hasViewPermission"></div>
                                                <a class="dropdown-item"
                                                   ng-if="host.hasViewPermission"
                                                   ui-sref="EventcorrelationsView({id: host.Host.id})">
                                                    <i class="fa fa-eye"></i>
                                                    <?php echo __('View'); ?>
                                                </a>

                                                <a class="dropdown-item"
                                                   ng-href="/eventcorrelation_module/eventcorrelations/summary_view_table/{{host.Host.id}}.pdf"
                                                   ng-if="host.hasViewPermission">
                                                    <i class="far fa-file-pdf"></i>
                                                    <?php echo __('Download as PDF'); ?>
                                                </a>
                                            <?php endif; ?>

                                            <?php if ($this->Acl->hasPermission('delete', 'eventcorrelations', 'EventcorrelationModule')): ?>
                                                <div class="dropdown-divider" ng-if="host.hasWritePermission"></div>
                                                <a ng-click="confirmDelete(getObjectForDelete(host.Host))"
                                                   ng-if="host.hasWritePermission"
                                                   href="javascript:void(0);"
                                                   class="dropdown-item txt-color-red">
                                                    <i class="fa fa-trash"></i>
                                                    <?php echo __('Delete'); ?>
                                                </a>
                                            <?php endif; ?>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                            </tbody>
                        </table>
                        <div class="margin-top-10" ng-show="evcHosts.length == 0">
                            <div class="text-center text-danger italic">
                                <?php echo __('No entries match the selection'); ?>
                            </div>
                        </div>
                        <div class="row margin-top-10 margin-bottom-10">
                            <div class="col-xs-12 col-md-2 text-muted text-center">
                                <span ng-show="selectedElements > 0">({{selectedElements}})</span>
                            </div>
                            <div class="col-xs-12 col-md-2">
                                <span ng-click="selectAll()" class="pointer">
                                    <i class="fas fa-lg fa-check-square"></i>
                                    <?php echo __('Select all'); ?>
                                </span>
                            </div>
                            <div class="col-xs-12 col-md-2">
                                <span ng-click="undoSelection()" class="pointer">
                                    <i class="fas fa-lg fa-square"></i>
                                    <?php echo __('Undo selection'); ?>
                                </span>
                            </div>

                            <?php if ($this->Acl->hasPermission('delete', 'hosttemplates')): ?>
                                <div class="col-xs-12 col-md-2 txt-color-red">
                                    <span ng-click="confirmDelete(getObjectsForDelete())" class="pointer">
                                        <i class="fas fa-trash"></i>
                                        <?php echo __('Delete selected'); ?>
                                    </span>
                                </div>
                            <?php endif; ?>
                        </div>
                        <scroll scroll="scroll" click-action="changepage" ng-if="scroll"></scroll>
                        <paginator paging="paging" click-action="changepage" ng-if="paging"></paginator>
                        <?php echo $this->element('paginator_or_scroll'); ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
