angular.module('openITCOCKPIT')
    .controller('EventcorrelationsSettingsIndexController', function($scope, $http, NotyService){

        $scope.init = true;

        var binaryConfigOptions = {
            EVC_CONSIDER_STATETYPE: 1 << 0,
            EVC_CONSIDER_STATE_COUNT: 1 << 1,
            EVC_REFLECT_CRITICAL_STATE: 1 << 2,
            EVC_SHOW_INFO_FOR_DISABLED_SERVICES: 1 << 3
        };

        $scope.load = function(){
            $http.get("/eventcorrelation_module/eventcorrelation_settings/index.json", {
                params: {
                    'angular': true
                }
            }).then(function(result){

                var config = parseInt(result.data.currentEventcorrelationSettings.configuration_option, 10);
                var monitoringEngine = result.data.currentEventcorrelationSettings.monitoring_system;
                var statusDisabledService = parseInt(result.data.currentEventcorrelationSettings.status_disabled_service, 10);

                $scope.post = {
                    monitoring_system: monitoringEngine,
                    status_disabled_service: statusDisabledService
                };

                for(var key in binaryConfigOptions){
                    $scope.post[key] = (binaryConfigOptions[key] & config) > 0;
                }

                $scope.init = false;

            }, function errorCallback(result){
                if(result.status === 403){
                    $state.go('403');
                }

                if(result.status === 404){
                    $state.go('404');
                }
            });
        };

        $scope.submit = function(){

            var post = {
                EventcorrelationSetting: {
                    monitoring_system: $scope.post.monitoring_system,
                    configuration_option: 0,
                    status_disabled_service: $scope.post.status_disabled_service
                }
            };

            for(var key in binaryConfigOptions){
                if($scope.post[key] === true){
                    post.EventcorrelationSetting.configuration_option += binaryConfigOptions[key];
                }
            }

            $http.post("/eventcorrelation_module/eventcorrelation_settings/index.json?angular=true",
                post
            ).then(function(result){
                NotyService.genericSuccess();
            }, function errorCallback(result){
                NotyService.genericError();
                if(result.data.hasOwnProperty('error')){
                    $scope.errors = result.data.error;
                }
            });

        };

        //Fire on page load
        $scope.load();
    });
